<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

require_once("config.php");
require_once("user/protect.php");
require_once("user/user-lib.php");
$add2=0;
if (file_exists("add2.php")){
	require_once("add2.php");
} 

@set_time_limit(3000);
@ini_set('max_execution_time', 900);

$db = new PDO(
      "mysql:host=".USER_DB_HOST.";dbname=".USER_DB_NAME.";charset=".USER_DB_CHARSET,
      USER_DB_USER, USER_DB_PASSWORD, [
      PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
      PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC
    ]);

if ($masterkeymode==false) {
	$query = "SELECT user_apikey FROM users WHERE user_id = :userid";
	$statement = $db->prepare($query);
	$statement->bindParam(':userid', $userid);
	$statement->execute();
	$result = $statement->fetch(PDO::FETCH_ASSOC);
	if ($result && !empty($result['user_apikey'])) {
		$api_key = $result['user_apikey'];
	} else {
		echo "NOUSERKEY";
		exit();
	}
} else {
	$api_key = $masterapikey;
}

// Check for credits system and set key accordingly

if ($add2==1){
	$api_key = $masterapikey;
}


$postfields = array();
foreach ($_POST as $key => $value) {
    $postfields[$key] = $value;
	$postfields[$key]=str_replace("'","",$postfields[$key]);
	$postfields[$key]=addslashes($postfields[$key]);			
}

$toneoptions = array(
	"1" => "Authoritative",
	"2" => "Casual",
	"3" => "Confident",
	"4" => "Conversational",
	"5" => "Educational",
	"6" => "Empathetic",
	"7" => "Encouraging",
	"8" => "Enthusiastic",
	"9" => "Friendly",
	"10" => "Informative",
	"11" => "Lighthearted",
	"12" => "Optimistic",
	"13" => "Persuasive",
	"14" => "Professional",
	"15" => "Straightforward",
	"16" => "Technical"
);
$tone="";
$tonenumber=$postfields["tone"];
if (isset($toneoptions[$tonenumber])) {
	$tone = $toneoptions[$tonenumber];
} 
$langoptions = [
    "1" => "Chinese",
    "2" => "Dutch",
    "3" => "English",
    "4" => "French",
    "5" => "German",
    "6" => "Italian",
    "7" => "Japanese",
    "8" => "Korean",
    "9" => "Portuguese",
    "10" => "Russian",
    "11" => "Spanish",
    "12" => "Vietnamese"
];
$language="";
$langnumber=$postfields["language"];
if (isset($langoptions[$langnumber])) {
	$language = $langoptions[$langnumber];
}

if (isset($postfields["mode"])){
	
	switch ($postfields["mode"]) {
		
		case "dotitles" :

			$prompt="Please conceive ten original book titles, designed specifically for [".$postfields["audience"]."], centered around the subject of [".$postfields["topic"]."]. The writing tone should be [".$tone."]. This information should be written in the language [".$language."]. These ideas should not be presented as a conventional list. Please generate a response without any line breaks or formatting. Provide a continuous block of text. Do not use markdown or HTML. I will process this data using a computer program, thus it is crucial to distinctly mark the beginning and ending of each concept.  Do not number the ideas. Do not use any form of numbering of titles or fields.  You must separate each title with the | symbol";
			sendPrompt($prompt,$aiengine,$api_key);
			break;
		
		case "dooutline" :
		
			if ($postfields["chapters"]>1) {
				$chapterinsert="chapters";
				$chapterinsert2="For each chapter output a title and a one sentence synopsis.  Before each title put the tag <chaptertitlestart> and after each title put the tag <chaptertitleend>.  Before each synopsis put the tag <chaptersynopsisstart> and after each synopsis put the tag <chaptersynopsisend>.";
			} else {
				$chapterinsert="chapter.  Please ensure you only create an outline for one single chapter. Do not create more than ONE CHAPTER in the outline.  Make sure the outline is for a single chapter as this is only a very short book.";
				$chapterinsert2="For the single chapter output a title and a one sentence synopsis.  Before the title put the tag <chaptertitlestart> and after the title put the tag <chaptertitleend>.  Before the synopsis put the tag <chaptersynopsisstart> and after the synopsis put the tag <chaptersynopsisend>.";
			}
			
			
			$prompt="You and I are going to write a book together. Write an outline for the book [".$postfields["booktitle"]."]. The book will target [".$postfields["audience"]."]. The book will have [".$postfields["chapters"]."] ".$chapterinsert." - The language used is [".$language."].  The tone of the writing should be [".$tone."].  ".$chapterinsert2."  Do not remind me what I asked you for. Do not apologize. Do not self-reference. Do not thank me.";
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		case "chapterpart1" :
		
			$prompt="Hello, we are writing a book together and I need your help. The language we should write the book in is [".$language."].  The book's title is [".$postfields["booktitle"]."], and right now, we're working on a chapter titled [".$postfields["chaptertitle"]."]. This chapter is about [".$postfields["chaptersynopsis"]."]. We're writing for an audience of [".$postfields["audience"]."], and the tone should be [".$tone."]. Here's the interesting part: We're only writing the first half of the chapter right now. I'll come back to you for the second half later. So, please don't wrap things up or write a conclusion yet. This is very important: [Do NOT write a conclusion or a summary at the end].  Let's leave the readers in suspense! Just stop the chapter at the end of a sentence without a conclusion and don't mention the 2nd part of the chapter as we want it to be a surprise - I trust you to understand that you will not write a conclusion at the end of this.  Do not remind me what I asked you for. Do not apologize. Do not self-reference. Do not thank me. In any output you must NOT make any mention of this being the first part of a the chapter because I want this to flow naturally to the next part that I will ask you to write.  With that in mind, write the first half of the chapter.  This first half you are now going to write should be a length of [".$postfields["wordcount"]."] words.";
			sendPrompt($prompt,$aiengine,$api_key);
			break;
			
		case "chapterpart2" :
			$previousoutput=urldecode($postfields["previousoutput"]);
			$prompt="You just wrote the first half of chapter to a book called [".$postfields["booktitle"]."].  The chapter is called [".$postfields["chaptertitle"]."].  The synopsis of the first half of the chapter you already wrote is [".$postfields["chaptersynopsis"]."], You wrote the following in the first half as a reminder of where you were up to: [".$postfields["previousoutput"]."]. The audience you are writing for is [".$postfields["audience"]."]. The tone of the writing should be [".$tone."]. The language to write in is [".$language."]. This is very important: [Do NOT reference that this is a continuation or 2nd part]. Do not say anything about the next chapter. Do not introduce the next chapter.  Do not mention that there are further chapters. Now continue writing the chapter by writing the second half. Write another [".$postfields["wordcount"]."] words.";			
			sendPrompt($prompt,$aiengine,$api_key);
			break;

		default :
			echo "UNKNOWN MODE";
			break;	
	}
	exit();
} else {
	echo ("NOMODE");
	exit();
}


function sendPrompt($prompt,$aiengine,$api_key){
	$endpoint="chat/completions";
	$modelname="gpt-3.5-turbo-16k";
	$aiengine=0; 
	if ($aiengine==0) {
		$endpoint="chat/completions";
		$modelname="gpt-3.5-turbo-16k";
	} else if ($aiengine==1) {
		$endpoint="chat/completions";
		$modelname="gpt-4";		
	}
	$curl = curl_init();
	curl_setopt_array($curl, array(
	  CURLOPT_URL => 'https://api.openai.com/v1/'.$endpoint,
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => '',
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 0,
	  CURLOPT_FOLLOWLOCATION => true,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => 'POST',
	  CURLOPT_POSTFIELDS =>'{"model":"'.$modelname.'","messages": [{"role": "user", "content": "'.$prompt.'"}],"temperature":1,"max_tokens":14000}',
	  CURLOPT_HTTPHEADER => array(
		'Authorization: Bearer '.$api_key,
		'Content-Type: application/json'
	  ),
	));
	$response = curl_exec($curl);

	if ($response===false){
		echo "APIERROR - ".curl_error($curl);
		curl_close($curl);
		exit();
	} else {
		if (isset($response['error']) && $response['status'] != 200) {
			//header("HTTP/1.1 500 Internal Server Error");
			print_r($response);
		} else {
			print_r($response);
		}		
		curl_close($curl);
		exit();
	}
	
}


?>
