<?php
require_once 'libs/dompdf/autoload.inc.php'; 
require_once("config.php");
require_once("user/protect.php");
require_once("user/user-lib.php");

use Dompdf\Dompdf; 
use Dompdf\Options;

$options = new Options();
$options->set('defaultFont', 'DejaVu Sans');
$options->set('isRemoteEnabled', TRUE);

$dompdf = new Dompdf($options);

$content = urldecode($_POST['content']);
$headerText = urldecode($_POST['headertext']);
$footerText = urldecode($_POST['footertext']);
$startPage = $_POST['startpage'];

$dompdf->loadHtml($content); 
$dompdf->setPaper('A4', 'portrait'); 

// Define header and footer text
//$headerText = "Training Manual {pnum} of {totalpages} of your amazing ebook";
//$footerText = "This is page {pnum} of {totalpages}";

$dompdf->render(); 

$canvas = $dompdf->get_canvas();

$canvas->page_script('
    if ($PAGE_NUM > '.$startPage.') {
        // Header
        $headerFont = $fontMetrics->get_font("Arial", "bold");
        $adjusted_page_num = $PAGE_NUM - '.$startPage.';
        $header = str_replace("{page}", $adjusted_page_num, "'.$headerText.'");
        $header = str_replace("{totalpages}", $PAGE_COUNT - '.$startPage.', $header);
        $headerWidth = $fontMetrics->get_text_width($header, $headerFont, 9);
        $pdf->text(($pdf->get_width() / 2) - ($headerWidth / 2), 10, $header, $headerFont, 9, array(0, 0, 0));

        // Page number / Footer
        $font = $fontMetrics->get_font("Arial", "bold");
        $footer = str_replace("{page}", $adjusted_page_num, "'.$footerText.'");
        $footer = str_replace("{totalpages}", $PAGE_COUNT - '.$startPage.', $footer);
        $width = $fontMetrics->get_text_width($footer, $font, 9);
        $pdf->text(($pdf->get_width() / 2) - ($width / 2), 820, $footer, $font, 9, array(0, 0, 0));
    }
');

$output = $dompdf->output();
$base64=base64_encode($output);
echo $base64;
exit();
?>
