<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

require_once("config.php");
require_once("user/protect.php");
require_once("user/user-lib.php");

$db = new PDO(
      "mysql:host=".USER_DB_HOST.";dbname=".USER_DB_NAME.";charset=".USER_DB_CHARSET,
      USER_DB_USER, USER_DB_PASSWORD, [
      PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
      PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC
    ]);

$projectname=$_POST["projectname"];
$grabdoc = urldecode(base64_decode($_POST['grabdoc']));
$category=$_POST["category"];
$bookid=$_POST["id"];
$headertext=$_POST["headertext"];
$footertext=$_POST["footertext"];
$startpage=$_POST["startpage"];


if ($bookid == 0) {
    $sql = "INSERT INTO ebooks (user_id, ebook_name, category, ebook_contents, date_created, last_edited, header_text, footer_text, start_page) VALUES (:user_id, :ebook_name, :category, :ebook_contents, NOW(), NOW(), :header_text, :footer_text, :start_page)";
    $stmt = $db->prepare($sql);
    $stmt->bindParam(':user_id', $userid);
    $stmt->bindParam(':ebook_name', $projectname);
    $stmt->bindParam(':category', $category);
    $stmt->bindParam(':ebook_contents', $grabdoc);
    $stmt->bindParam(':header_text', $headertext);
    $stmt->bindParam(':footer_text', $footertext);
    $stmt->bindParam(':start_page', $startpage);
    
    $stmt->execute();

    $lastId = $db->lastInsertId();
    echo $lastId;
	exit();

} else {
    $sql = "SELECT * FROM ebooks WHERE id = :bookid AND user_id = :user_id";
    $stmt = $db->prepare($sql);
    $stmt->bindParam(':bookid', $bookid);
    $stmt->bindParam(':user_id', $userid);

    $stmt->execute();

    if($stmt->rowCount() > 0) {
        $sql = "UPDATE ebooks SET ebook_name = :ebook_name, category = :category, ebook_contents = :ebook_contents, last_edited = NOW(), header_text=:header_text, footer_text=:footer_text, start_page=:start_page WHERE id = :bookid";
        $stmt = $db->prepare($sql);
        $stmt->bindParam(':ebook_name', $projectname);
        $stmt->bindParam(':category', $category);
        $stmt->bindParam(':ebook_contents', $grabdoc);
        $stmt->bindParam(':bookid', $bookid);
		$stmt->bindParam(':header_text', $headertext);
		$stmt->bindParam(':footer_text', $footertext);
		$stmt->bindParam(':start_page', $startpage);
			
        $stmt->execute();
        
        echo $bookid;
		exit();
        
    } else {
        echo "ERROR";
    }
}

?>
