<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

require_once("config.php");
require_once("user/protect.php");
require_once("user/user-lib.php");
$add2=0;
if (file_exists("add2.php")){require_once("add2.php");}
if ($add2==1){$showcredits="";}else{$showcredits="display:none;";}

$id=-1;

if (isset($_GET["id"])){$id=intval($_GET["id"]);}

if ($id===-1){
	header("location:ebooks.php");
}

	
$db = new PDO(
      "mysql:host=".USER_DB_HOST.";dbname=".USER_DB_NAME.";charset=".USER_DB_CHARSET,
      USER_DB_USER, USER_DB_PASSWORD, [
      PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
      PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC
    ]);


$st = $db->prepare("SELECT cat_id,cat_name FROM categories WHERE cat_userid=:userid");
$st->bindParam(':userid', $userid);
$st->execute();
$user=[];
$results = $st->fetchAll();
$catout="";
if ($results){
	
	foreach ($results as $key => $value) {
		$catout.='<option value="'.$value["cat_id"].'">'.$value["cat_name"].'</option>';
	}
} else {
	$catout="";
}
$ebook_name="";
$category=0;
$ebook_contents="";
$headertext="";
$footertext="";
$startpage=2;

if($id > 0){
	$query = $db->prepare("SELECT ebook_name, category, ebook_contents, header_text, footer_text, start_page FROM ebooks WHERE id = :id AND user_id = :user_id");
	$query->execute(['id' => $id, 'user_id' => $userid]);
	$result = $query->fetch(PDO::FETCH_ASSOC);
	if($result === false){
		header('Location: ebooks.php');
		exit();
	}
	$ebook_name = $result['ebook_name'];
	$category = $result['category'];
	$ebook_contents = $result['ebook_contents'];
	$headertext = $result['header_text'];
	$footertext = $result['footer_text'];
	$startpage = $result['start_page'];
}

$usercredits=1000000;
// Check for available credits if not editmode and credits system installed
if ($add2==1){
	$usercredits=0;
	if($id==0){
		try {
			$query = "SELECT user_credits FROM users WHERE user_id = :userid";
			$stmt = $db->prepare($query);
			$stmt->bindParam(':userid', $userid, PDO::PARAM_INT);
			$stmt->execute();
			$result = $stmt->fetch(PDO::FETCH_ASSOC);
			
			if ($result) {
				$usercredits = $result['user_credits'];
			} else {
				echo "No user found with the given user_id.";
			}

		} catch(PDOException $e) {
			echo "Error getting words left";
		}
		if ($usercredits<200) {
			header("location:ebooks.php?w=1");
		}
	}
}
if ($id!=0){$showcredits="display:none;";}

?>
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title><?php echo $sitename; ?></title>

    <!-- Custom fonts for this template -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.9.0/css/all.min.css" integrity="sha512-q3eWabyZPc1XTCmF+8/LuE1ozpg5xxn7iO89yfSOd5/oKvyqLngoNGsx8jq92Y8eXJ/IRxQbEC+FGSYxtk2oiw==" crossorigin="anonymous" referrerpolicy="no-referrer" />
    <link
        href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
        rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="libs/sbadmin2/css/sb-admin-2.min.css" rel="stylesheet">

    <!-- Custom styles for this page -->
	<style>
		.topgap {
			margin-top: 15px;
		}
		.topgap2 {
			margin-top: 20px;
		}
		#overlay {
			position: fixed;
			top: 0;
			left: 0;
			height: 100vh;
			width: 100vw;
			background-color: rgba(0, 0, 0, 0.6);
			display: none;
			align-items: center;
			justify-content: center;
			z-index: 9999;
		}

		#overlay.display-flex {
			display: flex;
		}

		#overlay-text {
			color: white;
			font-family:Nunito;
			font-size: 24px;
			pointer-events: none;
			user-select: none;
		}
		.no-select {
			user-select: none;
		}
		.fake-input {
			user-select: none; /* This prevents the content from being selected */
			display: flex;
			align-items: center;
			justify-content: space-between;
			padding-right: 10px;
		}		
	</style>	

</head>

<body id="page-top">

    <!-- Page Wrapper -->
    <div id="wrapper">

       <?php require_once("menu_sidenav.php"); ?>
        <!-- Content Wrapper -->
        <div id="content-wrapper" class="d-flex flex-column">

            <!-- Main Content -->
            <div id="content">

                <!-- Begin Page Content -->
                <div class="container-fluid" style="margin-top:50px;"	>

                    <!-- Page Heading -->
                    <h1 class="h3 mb-2 text-gray-800">Ebook Creation / Editing</h1>
                    <p class="mb-4">
					You can create and edit your ebooks here.
					</p>

                    <div class="card shadow mb-4" id="outerWrapper" style="display:none;">
                        <div class="card-header py-3">
							<input id="add2" style="display:none;" value="<?php echo($add2); ?>">
							<input id="booktitlestorage" style="display:none;">
							<input id="actualchapters" style="display:none;">
							<input id="whichbuttonstep2" style="display:none;">
							<input id="ebook_id" style="display:none;" value="<?php echo($id); ?>">
							<input id="ebook_category" style="display:none;" value="<?php echo($category); ?>">
							<textarea id="ebook_contents" style="display:none;" ><?php echo($ebook_contents); ?></textarea>
							<a href="ebooks.php" id="cancelButton" class="btn btn-danger btn-icon-split float-right" style="margin-right:5px;"><span class="icon text-white-50"><i class="fas fa-window-close"></i></span><span class="text">Cancel</span></a>
							<button id="regenButton" data-step="1" type="button" class="btn btn-info btn-icon-split float-right" style="margin-right:5px; display:none;"><span class="icon text-white-50"><i class="fas fa-redo-alt"></i></span><span class="text">Regen</span></button>
							<button id="backButton" data-step="1" type="button" class="btn btn-warning btn-icon-split float-right" style="margin-right:5px; display:none;"><span class="icon text-white-50"><i class="fas fa-angle-double-left"></i></span><span class="text">Back</span></button>
							<span class="float-left form-inline" style="<?php echo $showcredits; ?>">Words Left:&nbsp;&nbsp;<div class="form-control fake-input" id="usercredits" readonly ><?php echo $usercredits; ?></div><input id="userid" type="text" style="display:none;" value="<?php echo $userid; ?>"></span>
                        </div>
                        <div class="card-body">
							<div id="step1">
							<div class="row topgap">
								<div class="col-12">
									<div class="alert alert-secondary">Please enter some information about what you want to create and click Next</div>
								</div> 
							</div>
								<div class="row">
									<div class="col-3">
										<label>Project Name</label>
										<input type="text" class="form-control validate" placeholder="Name (internal use - 50 chars)" maxlength="50" name="projectname" id="projectname" value="<?php echo $ebook_name; ?>">
										<label class="form-check-label text-danger" style="display:none;" for="projectname">You must provide a project name!</label>
									</div>
						
									<div class="col-3">
										<label for="category">Category</label>
										<div class="input-group">
											<select name="category" id="category" class="form-control custom-select">
												<option value="0">No Category</option>
												<?php echo $catout; ?>
											</select>
											<div class="input-group-append">
												<button class="btn btn-outline-secondary addcatbutton" type="button" id=""><i class="fas fa-plus-circle"></i></button>
											</div>
										</div>
									</div>

									<div class="col-2">
									<label>No. Chapters</label><br>
										<div class="input-group">
											<span class="input-group-prepend">
												<button type="button" class="btn btn-outline-secondary btn-number" data-type="minus" data-field="chapters">
													<span class="fa fa-minus"></span>
												</button>
											</span>
											<input type="text" name="chapters" id="chapters" class="form-control input-number" value="5" min="3" max="20">
											<span class="input-group-append">
												<button type="button" class="btn btn-outline-secondary btn-number" data-type="plus" data-field="chapters">
													<span class="fa fa-plus"></span>
												</button>
											</span>
										</div>
									</div>
									<div class="col-2">
									<label>Max Words Per Chapter</label><br>
										<div class="input-group">
											<span class="input-group-prepend">
												<button type="button" class="btn btn-outline-secondary btn-number" data-type="minus" data-field="wordsperchapter">
													<span class="fa fa-minus"></span>
												</button>
											</span>
											<input type="text" name="wordsperchapter" id="wordsperchapter" class="form-control input-number" value="1000" min="100" max="2000">
											<span class="input-group-append">
												<button type="button" class="btn btn-outline-secondary btn-number" data-type="plus" data-field="wordsperchapter">
													<span class="fa fa-plus"></span>
												</button>
											</span>
										</div>
									</div>
									<div class="col-2">
										<label>Language</label><br>
										<select name="language" id="language" class="form-control custom-select" style="">
											<option value="1">Chinese</option>
											<option value="2">Dutch</option>
											<option value="3" selected="selected">English</option>
											<option value="4">French</option>
											<option value="5">German</option>
											<option value="6">Italian</option>
											<option value="7">Japanese</option>
											<option value="8">Korean</option>
											<option value="9">Portuguese</option>
											<option value="10">Russian</option>
											<option value="11">Spanish</option>
											<option value="12">Vietnamese</option>
										</select>
									</div>
								</div>
								<div class="row topgap">
									<div class="col-6">
										<label>Book Topic</label>
										<input type="text" class="form-control validate" placeholder="Topic of book (200 chars)" maxlength="200" name="topic" id="topic" value="">
										<label class="form-check-label text-danger" style="display:none;" for="topic">You must provide a book topic!</label>
									</div>
									<div class="col-2">
										<label>Target Audience</label>
										<input type="text" class="form-control validate" placeholder="Target Audience (200 chars)" maxlength="200" name="audience" id="audience" value="">
										<label class="form-check-label text-danger" style="display:none;" for="audience">You must provide a target audience!</label>
									</div>
									<div class="col-2">
										<label>Writing Tone</label>
										<select name="tone" id="tone" class="form-control custom-select" style="">
											<option value="1">Authoritative</option>
											<option value="2">Casual</option>
											<option value="3">Confident</option>
											<option value="4">Conversational</option>
											<option value="5">Educational</option>
											<option value="6">Empathetic</option>
											<option value="7">Encouraging</option>
											<option value="8">Enthusiastic</option>
											<option value="9">Friendly</option>
											<option value="10" selected="selected">Informative</option>
											<option value="11">Lighthearted</option>
											<option value="12">Optimistic</option>
											<option value="13">Persuasive</option>
											<option value="14">Professional</option>
											<option value="15">Straightforward</option>
											<option value="16">Technical</option>
										</select>										
									</div>
									<div class="col-2">
									<label>&nbsp;</label><br>
										<button id="step1Next" class="btn btn-success btn-icon-split float-right" style="margin-right:5px;"><span class="icon text-white-50"><i class="fas fa-angle-double-right"></i></span><span class="text">Next</span></button>
									</div>
								</div>
							</div>
							
							<div id="step2" style="display:none">
								<div class="row topgap">
									<div class="col-12">
										<div class="alert alert-secondary">Please choose/edit the title for your eBook the Next button of your choice</div>
									</div> 
								</div>
								
										<?php for ($i=0; $i<=9; $i++){
											echo '<div class="row topgap"><div class="col-6"><input type="text" class="form-control" style="background-color:white;" id="title'.$i.'" value=""></div><button data-id="step2button'.$i.'" class="btn  btn-success btn-icon-split step2Next" style=""><span class="icon text-white-50"><i class="fas fa-angle-double-right"></i></span><span class="text">Next</span></button></div>';
										} ?>
										
							</div>
							<div id="step3" style="display:none;">
								<div class="row topgap">
									<div class="col-12">
										<div class="alert alert-secondary">Your eBook outline for : <span id="booktitle"></span> - Edit if needed & press NEXT to create</div>
									</div>
								</div>
								
								<div class="row topgap" style="margin-botton:9px;">
									<div class="col-4">
										Section/Chapter (edit if needed)
									</div>
									<div class="col-6">
										Description (edit if needed)
									</div>
								</div>
								<div id="outlineRows">
								</div>
							</div>

							<div id="step4" style="display:none;">
								<div class="row topgap">
									<div class="col-12">
										<div class="alert alert-secondary">Your completed eBook</div>
									</div>
								</div>

								<div class="row" >
									<div class="col-2">
										<label>Project Name</label>
										<input type="text" class="form-control validate" placeholder="Name (internal use - 50 chars)" maxlength="50" name="projectnameEdit" id="projectnameEdit" value="<?php echo $ebook_name; ?>">
										<label class="form-check-label text-danger" style="display:none;" for="projectname">You must provide a project name!</label>
									</div>
									<div class="col-2">
										<label for="category">Category</label>
										<div class="input-group">
											<select name="category" id="categoryEdit" class="form-control custom-select">
												<option value="0">No Category</option>
												<?php echo $catout; ?>
											</select>
											<div class="input-group-append">
												<button class="btn btn-outline-secondary addcatbutton" type="button" id=""><i class="fas fa-plus-circle"></i></button>
											</div>
										</div>
									</div>
									<div class="col-3">
										<label>PDF Header</label>
										<input type="text" class="form-control" placeholder="Header Text (if required)" maxlength="100" name="headertext" id="headertext" value="<?php echo $headertext; ?>">
									</div>
									<div class="col-3">
										<label>PDF Footer</label>
										<input type="text" class="form-control" placeholder="Footer Text (if required)" maxlength="100" name="footertext" id="footertext" value="<?php echo $footertext; ?>">
									</div>
									<div class="col-2">
									<label>PDF Start Page #</label><br>
										<div class="input-group">
											<span class="input-group-prepend">
												<button type="button" class="btn btn-outline-secondary btn-number" data-type="minus" data-field="startpage">
													<span class="fa fa-minus"></span>
												</button>
											</span>
											<input type="text" name="startpage" id="startpage" class="form-control input-number" value="<?php echo $startpage; ?>" min="1" max="100">
											<span class="input-group-append">
												<button type="button" class="btn btn-outline-secondary btn-number" data-type="plus" data-field="startpage">
													<span class="fa fa-plus"></span>
												</button>
											</span>
										</div>
									</div>									
								</div>
								<div class="row topgap">
									<div class="col-12">
									<div class="alert alert-info"><b>NOTE:</b> Headers & Footers can contain shortcodes {page} for Page Number and {totalpages} for Total Pages - Start Page is the page to start numbering from. This is for PDF only.</div>
									</div>
								</div>
								
								<div class="row topgap">
									<div class="col-12">
										<div id="editorarea"></div>
									</div>
								</div>
								<div class="row topgap">
									<div class="col-12">
										<div id="docHtml" class="googoose-wrapper" style="display:none;"></div>
										<a href="ebooks.php" class="btn btn-danger btn-icon-split float-right" style="margin-right:5px;"><span class="icon text-white-50"><i class="fas fa-window-close"></i></span><span class="text">Exit</span></a>										
										<button id="saveBook" class="btn btn-success btn-icon-split float-right" style="margin-right:5px;"><span class="icon text-white-50"><i class="fas fa-save"></i></span><span class="text">Save</span></button>
										<div class="btn-group float-right" style="margin-right:10px">
											<button type="button" class="btn btn-primary">Export</button>
											<button type="button" class="btn btn-primary dropdown-toggle dropdown-toggle-split" data-toggle="dropdown"></button>
											<div class="dropdown-menu">
												<a class="dropdown-item exportbutton" data-id="doc" href="#">DOC File</a>
												<a class="dropdown-item exportbutton" data-id="txt" href="#">Text File</a>
												<a class="dropdown-item exportbutton" data-id="pdf" href="#">PDF File</a>
											</div>
										</div>										
									</div>
								</div>
							</div>

							
                        </div>
                    </div>

                </div>
                <!-- /.container-fluid -->

            </div>
            <!-- End of Main Content -->

            <!-- Footer -->
            <footer class="sticky-footer bg-white">
                <div class="container my-auto">
                    <div class="copyright text-center my-auto">
                        <?php echo $footer; ?>
                    </div>
                </div>
            </footer>
            <!-- End of Footer -->

        </div>
        <!-- End of Content Wrapper -->

    </div>
    <!-- End of Page Wrapper -->

    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
        <i class="fas fa-angle-up"></i>
    </a>

    <!-- AI Error Modal -->
    <div class="modal fade" id="s2errorModal" tabindex="-1" role="dialog" aria-labelledby="s2ErrorLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="s2ErrorLabel">AI Error</h5>
                    <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <div class="modal-body">There has been a problem connecting to the AI. This could be because the service is currently too busy.  Please try again.</div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" type="button" data-dismiss="modal">OK</button>
                </div>
            </div>
        </div>
    </div>
	
	<!-- API Key Error Modal -->
    <div class="modal fade" id="userkeyModal" tabindex="-1" role="dialog" aria-labelledby="userkeyLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="userkeyLabel">API Key Error</h5>
                    <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <div class="modal-body">There has been a problem connecting to the AI. Your OpenAI API key is either missing or invalid - Please set it correctly in your Settings dashboard.</div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" type="button" data-dismiss="modal">OK</button>
                </div>
            </div>
        </div>
    </div>	

	<!-- Add Category Modal -->
    <div class="modal fade" id="addcatModal" tabindex="-1" role="dialog" aria-labelledby="addcatLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="addcatLabel">Add New Category</h5>
                    <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <div class="modal-body">
					<div class="row">
						<div class="col-12">
							<label>New Category</label>
							<input type="text" class="form-control" placeholder="New Category" maxlength="50" name="addcat" id="addcat" value="">
						</div>
					</div>
				</div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary btn-icon-split" data-dismiss="modal"><span class="icon text-white-50"><i class="fas fa-window-close"></i></span><span class="text">Cancel</span></button>
					<button type="button" class="btn btn-primary btn-icon-split" onclick="addNewCat();" data-dismiss="modal"><span class="icon text-white-50"><i class="fas fa-plus-circle"></i></span><span class="text">Add Category</span></button>
                </div>
            </div>
        </div>
    </div>	


	<div class="toast bg-gray-400" role="alert" aria-live="assertive" aria-atomic="true" data-delay="5000" style="position: absolute; top: 1rem; right: 1rem;" id="generalToast">
	  <div class="toast-header bg-gray-700">
		<strong class="mr-auto"><span id="generalToastHeader" style="color:#FFF;"></span></strong>
		<button type="button" class="ml-2 mb-1 close" data-dismiss="toast" aria-label="Close">
		  <span aria-hidden="true" style="color:#FFF;">&times;</span>
		</button>
	  </div>
	  <div class="toast-body">
		<span id="generalToastBody" style="color:#000"></span>
	 </div>
	</div>

    <!-- Bootstrap core JavaScript-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js" integrity="sha512-894YE6QWD5I59HgZOGReFYm4dnWc1Qt5NtvYSaNcOP+u1T9qYdvdihz0PPSiiqn/+/3e7Jo4EaG7TubfWGUrMQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/4.6.2/js/bootstrap.bundle.min.js" integrity="sha512-igl8WEUuas9k5dtnhKqyyld6TzzRjvMqLC79jkgT3z02FvJyHAuUtyemm/P/jYSne1xwFI06ezQxEwweaiV7VA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <!-- Core plugin JavaScript-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.4.1/jquery.easing.min.js" integrity="sha512-0QbL0ph8Tc8g5bLhfVzSqxe9GERORsKhIn1IrpxDAgUsbBGz/V7iSav2zzW325XGd1OMLdL4UiqRJj702IeqnQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

    <!-- Custom scripts for all pages-->
    <script src="libs/sbadmin2/js/sb-admin-2.min.js"></script>

	<!-- Page level plugins -->
	<script type="text/javascript" src="https://cdn.jsdelivr.net/gh/aadel112/googoose@master/jquery.googoose.js"></script>

	<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/6.4.2/tinymce.min.js" integrity="sha512-sWydClczl0KPyMWlARx1JaxJo2upoMYb9oh5IHwudGfICJ/8qaCyqhNTP5aa9Xx0aCRBwh71eZchgz0a4unoyQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>



<script>
function generalToast(header,body){
			$('#generalToastHeader').text(header);
			$('#generalToastBody').text(body);
			$('#generalToast').toast('show');
}

$('.addcatbutton').click(function(){
	$('#addcatModal').modal('show');
});

function addNewCat(whichsection){
	var newcat=$('#addcat').val().trim();
	if (newcat!=""){
		$('#addcat').val('');
		$.ajax({
			url: "AJAX_addnewcat.php",
			data: {newcatname:newcat},
			type: 'POST',
			success: function (response) {
				if (response!="ERROR"){
					$('#tablediv').show();
					var data = JSON.parse(response);
					var catId = data.cat_id;
					var catName = data.cat_name;
					var option = new Option(catName, catId);
					$('#category,#categoryEdit').append(option);
					$('#category,#categoryEdit').val(catId);
					$('#category,#categoryEdit').change();
					generalToast('Category Added','This Category has been added');
					
					$('#categoryEdit').change();					
				} else {
					generalToast('ERROR!','This Category has NOT been added');
				}
			}
		});			
	}
	
}

function b64toBlob(b64Data, contentType, sliceSize) {
    contentType = contentType || '';
    sliceSize = sliceSize || 512;

    var byteCharacters = atob(b64Data);
    var byteArrays = [];

    for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
        var slice = byteCharacters.slice(offset, offset + sliceSize);

        var byteNumbers = new Array(slice.length);
        for (var i = 0; i < slice.length; i++) {
            byteNumbers[i] = slice.charCodeAt(i);
        }

        var byteArray = new Uint8Array(byteNumbers);
        byteArrays.push(byteArray);
    }

    var blob = new Blob(byteArrays, {type: contentType});
    return blob;
}

$('#backButton').click(function() {
	if(enoughWords()==false){
		generalToast('Cannot Go Back','Sorry you do not have enough words left.');
	} else {	
		
		var currentStep=$(this).data('step');
		
		$('#step'+currentStep).hide();
		currentStep--;
		$('#step'+currentStep).show();
		$('#backButton,#regenButton').data('step',currentStep);
		if (currentStep==1){
			$('#backButton,#regenButton').hide();
		}
	}
});

$('#saveBook').click(function(){
	
	var grabdoc = '<style>p { color: black; font-size: 12pt; font-family: Verdana; }</style>'+tinymce.get("editorarea").getContent();
	var ebook_id=$('#ebook_id').val();
	var projectname=$('#projectnameEdit').val();
	var category=$('#categoryEdit').val();
	var headertext=$('#headertext').val();
	var footertext=$('#footertext').val();
	var startpage=$('#startpage').val();
	
	$('#saveBook').html('<span class="icon text-white-50"><i class="fas fa-sync-alt fa-spin"></i></span><span class="text">Saving</span>').prop('disabled',true);
	var id=$('#ebook_id').val();
	grabdoc=encodeURIComponent(grabdoc);
	var data = {
	  projectname: projectname,
	  grabdoc: btoa(unescape(encodeURIComponent(grabdoc))), 
	  category: category,
	  id: id,
	  headertext: headertext,
	  footertext: footertext,
	  startpage: startpage
	};	
	
	
	$.ajax({
	  url: 'AJAX_save.php',
	  type: 'POST',
	  data: data,
	  success: function(response) {
		$('#saveBook').html('<span class="icon text-white-50"><i class="fas fa-save"></i></span><span class="text">Save</span>').prop('disabled',false);
		
		generalToast('eBook Saved!','Your eBook has been saved.');
		$('#ebook_id').val(response);
	  },
	  error: function(xhr, status, error) {
			console.log("ERROR WITH SAVE");
	  }
	});	
	
});

$('.exportbutton').click(function(){
	let whichbutton=$(this).data('id');
	var grabdoc = tinymce.get("editorarea").getContent();
	$('#docHtml').html('<style>p { color: black; font-size: 12pt; font-family: Verdana; }</style>'+grabdoc);
	var filename=$('#projectnameEdit').val();
	filename = filename.replace(/\W+/g, " ");
	filename = filename.replace(/\s+/g, "-");
	switch(whichbutton){

		case "txt":
			var grabtext = tinymce.get("editorarea").getContent({ format: "text" });
			var blob = new Blob([grabtext], {type: "text/plain"});
			var url = URL.createObjectURL(blob);
			var a = document.createElement('a');
			a.href = url;
			a.download = filename+'.txt';
			document.body.appendChild(a);
			a.click();
			document.body.removeChild(a);
			generalToast('Text File Created','Text File Created : '+filename+'.txt');
		break;
		
		case "doc":
			var o = {
				filename: filename+'.doc'
			};
			$('#docHtml').show();
			$(document).googoose(o);
			$('#docHtml').hide();
			generalToast('Doc File Created','DOC File Created : '+filename+'.doc');
		break;
		
		case "pdf":
			grabdoc='<style>p { color: black; font-size: 12pt; font-family: Verdana; } img { max-width:100%; height:auto; }</style>'+grabdoc;
			headertext=$('#headertext').val();
			footertext=$('#footertext').val();
			startpage=$('#startpage').val();
			$.ajax({
				url: 'AJAX_dopdf.php',
				type: 'POST',
				data: { 
					content: encodeURIComponent(grabdoc),
					headertext: encodeURIComponent(headertext),
					footertext: encodeURIComponent(footertext),
					startpage: startpage
					
				},
				 success: function(response) {
						var blob = b64toBlob(response, "application/pdf");
						var blobUrl = URL.createObjectURL(blob);

						var link = $('<a>');
						link.attr('href', blobUrl);
						link.attr('download', filename+'.pdf');

						$('body').append(link);
						link[0].click();
						link.remove();
					},
					error: function(xhr, status, error) {

						console.log("Error Creating PDF");
					}
			});	
			generalToast('PDF File Created','PDF File Created : '+filename+'.pdf');
		break;
		
	}
	
});




$('#regenButton').click(function() {
	if(enoughWords()==false){
		generalToast('Cannot Regen!','Sorry you do not have enough words left.');
	} else {
		var buttonStep=$(this).data('step');
		
		switch (buttonStep) {
			case 2:
				$('#step1Next').click();
			break;
			case 3:
				let whichbutton=$('#whichbuttonstep2').val();
				$('#step3 .outlinerow').remove();
				$('button[data-id="'+whichbutton+'"]').click();
			break;
			case 4:
				$('#step3Next').click();
			break;
		}
	}
});

$("#step1Next").click(function() {
	if(enoughWords()==false){
		generalToast('Cannot Proceed','Sorry you do not have enough words left.');
	} else {
		var isValid=true;
		$('#projectnameEdit').val($('#projectname').val());
		$('#categoryEdit').val($('#category').val());
		$('#categoryEdit').change();
		$('.validate').each(function() {
			var input = $(this);
			var label = $("label[for='" + input.attr('id') + "']");
			if (input.val().trim() === '') {
				label.show();
				input.addClass('is-invalid');
				isValid=false;
			} else {
				label.hide();
				input.removeClass('is-invalid');
			}
		});
		if (isValid==true){
			showOverlay(true);
			$('#regenButton,#backButton').data('step',2);
			$('#overlay-message').text('Asking AI to come up with book ideas - Please wait...');
			var projectname = $('#projectname').val();
			var language = $('#language').val();
			var chapters = $('#chapters').val();
			var wordsperchapter = $('#wordsperchapter').val();
			var wordsinintro = $('#wordsinintro').val();
			var topic = $('#topic').val();
			var audience = $('#audience').val();
			var tone = $('#tone').val();
			var mode = 'dotitles';
			var data = {
			  projectname: projectname,
			  language: language,
			  chapters: chapters,
			  wordsperchapter: wordsperchapter,
			  wordsinintro: wordsinintro,
			  topic: topic,
			  audience: audience,
			  tone: tone,
			  mode: mode
			};
			$.ajax({
			  url: 'AJAX_aiengine.php',
			  type: 'POST',
			  data: data,
			  success: function(response) {
				
				let errortest;

				try {
				  errortest = JSON.parse(response);
				} catch (error) {
				  console.error("The response is not valid JSON");
					console.log("ERROR WITH AJAX CALL 1!!");
					showOverlay(false);
					$('#s2errorModal').modal('show');				  
				  errortest=response;
				}
				if (errortest=="NOUSERKEY") {
					console.log("ERROR WITH AJAX CALL 1!!");
					showOverlay(false);
					$('#userkeyModal').modal('show');	
				} else if (errortest.error || response.indexOf('|') == -1 || response=='NOUSERKEY'){
					console.log("ERROR WITH AJAX CALL 1!!");
					showOverlay(false);
					$('#s2errorModal').modal('show');				
				} else {
					showOverlay(false);
					$('#step1').hide();
					$('#regenButton,#backButton').show();
					$('#step2').show();
					var airesp = JSON.parse(response);
					var content = airesp.choices[0].message.content;
					var content = content.replace(/\n/g, '');
					content=content.replaceAll("<\/","<");
					content = content.replaceAll('<\\', '<');
					content = content.replaceAll('</', '<');
					content = content.replaceAll(/["']/g, "");
					const contentarray = content.split("|").map(item => item.trim());
					for (let i = 0; i < 10; i++) {
						$('#title'+i).val(contentarray[i]);
					}
				}
			  },
			  error: function(xhr, status, error) {
					showOverlay(false);
					$('#s2errorModal').modal('show');
			  }
			});
		}
	}
});

$('.step2Next').click(function() {
	if(enoughWords()==false){
		generalToast('Cannot Proceed','Sorry you do not have enough words left.');
	} else {	
		whichbutton=$(this).data('id');
		$('#whichbuttonstep2').val(whichbutton);
		var booktitle=$('#title'+$(this).data('id').replace('step2button','')).val();
		$('#booktitlestorage').val(booktitle);
		showOverlay(true);
		$('#regenButton,#backButton').data('step',3);
		$('#overlay-message').text('Asking AI to generate outline - Please wait...');

		var language = $('#language').val();
		var chapters = $('#chapters').val();
		var audience = $('#audience').val();
		var tone = $('#tone').val();
		var mode = 'dooutline';
		var data = {
			booktitle: booktitle,
			language: language,
			chapters: chapters,
			audience: audience,
			tone: tone,
			mode: mode
		};
		$.ajax({
		  url: 'AJAX_aiengine.php',
		  type: 'POST',
		  data: data,
		  success: function(response) {
			
			try {
			  errortest = JSON.parse(response);
			} catch (error) {
				console.error("The response is not valid JSON");
				console.log("ERROR WITH AJAX CALL 2!!");
				showOverlay(false);
				$('#s2errorModal').modal('show');	
				errortest=response;
			}
			if (errortest.error){
				console.log("ERROR WITH AJAX CALL 2!!");
				showOverlay(false);
				$('#s2errorModal').modal('show');				
			} else {		  
				showOverlay(false);
				$('#booktitle').html('<b><i>'+booktitle+'</b></i>')
				$('#step2').hide();
				$('#step3').show();
				var airesp = JSON.parse(response);
				
				var content = airesp.choices[0].message.content;

				content = content.replace(/\n/g, '');

				content=content.replaceAll("<\/","<");
				content = content.replaceAll('<\\', '<');
				content = content.replaceAll('</', '<');
				content = content.replaceAll(/["']/g, "");
				content = content.replaceAll("start:","start>");
				content = content.replaceAll("end:","end>");
				var chaptertitleRegex = /<chaptertitlestart>(.*?)<chaptertitleend>/g;
				var chaptertitles = [];
				var match;
				while (match = chaptertitleRegex.exec(content)) {
					chaptertitles.push(match[1]);
				}		
				var chaptersynopsisRegex = /<chaptersynopsisstart>(.*?)<chaptersynopsisend>/g;
				var chaptersynopses = [];
				var match;
				while (match = chaptersynopsisRegex.exec(content)) {
					chaptersynopses.push(match[1]);
				}
				$('#outlineRows').html('');
				chapnum=0;
				for (var i = 0; i < chaptertitles.length-1; i++) { 
					var chapnum=i+1;
					$('#outlineRows').append('<div class="row outlinerow"><div class="col-4"><input id="chaptertitle'+chapnum+'" class="form-control" style="border-radius:0px;" value="'+chaptertitles[i]+'"></div><div class="col-6"><input class="form-control" style="border-radius:0px;" maxlength="200" id="chaptersynopsis'+chapnum+'" value="'+chaptersynopses[i]+'"></div></div>');
				}
				
				chapnum++;
				$('#outlineRows').append('<div class="row outlinerow"><div class="col-4"><input id="chaptertitle'+chapnum+'" class="form-control" style="border-radius:0px;" value="'+chaptertitles[i]+'"></div><div class="col-6"><input class="form-control" style="border-radius:0px;" maxlength="200" id="chaptersynopsis'+chapnum+'" value="'+chaptersynopses[i]+'"></div><div class="col-2"><button id="step3Next" class="btn btn-success btn-icon-split float-right" style="margin-right:5px;"><span class="icon text-white-50"><i class="fas fa-angle-double-right"></i></span><span class="text">Next</span></button></div></div>');
				
				$('#actualchapters').val(chapnum);
				
			}
		  },
		  error: function(xhr, status, error) {
			console.log("ERROR WITH AJAX CALL 2!!");
			
			showOverlay(false);
			$('#s2errorModal').modal('show');
		  }
		});	
	}
});




$(document).on('click', '#step3Next', async function() {
	if(enoughWords()==false){
		generalToast('Cannot Proceed','Sorry you do not have enough words left.');
	} else {	
		$('#regenButton,#backButton').data('step',4);
		var projectname = $('#projectname').val();
		var language = $('#language').val();
		var chapters = $('#actualchapters').val();
		var wordsperchapter = $('#wordsperchapter').val();
		var topic = $('#topic').val();
		var audience = $('#audience').val();
		var tone = $('#tone').val();
		var booktitle=$('#booktitlestorage').val();
		var wordcount1=wordsperchapter/2;
		wordcount1=parseInt(wordcount1);
		var wordcount2=wordsperchapter-wordcount1;
		
		var finaloutput='<br><br><br><br><div style="text-align:center;"><h1 style="font-family:Verdana;">'+booktitle+'</h1></div><hr><br><br><div style="page-break-before: always;"></div><br>';
		finaloutput+='<div style="text-align:center;"><h4 style="font-family:Verdana;">Contents</h4></div><br><br>';
		for (chapter=1; chapter<=chapters; chapter++){
			finaloutput+='<div style="text-align:center;"><h5 style="font-family:Verdana;">'+$('#chaptertitle'+chapter).val()+'</h5></div>';
		}
		finaloutput+='<br><hr><div style="page-break-before: always;"></div>';
		
		
		var progress=0;
		for (chapter=1; chapter<=chapters; chapter++){

			var chaptertitle=$('#chaptertitle'+chapter).val();
			var chaptersynopsis=$('#chaptersynopsis'+chapter).val();
		
			var wordcount=wordcount1;
			var mode="chapterpart1";
			var previousoutput='';

			try {
				var chapteroutput1 = await getChapter(progress, chapter, projectname, language, chapters, wordcount, topic, audience, tone, booktitle, mode, chaptertitle, chaptersynopsis, previousoutput);
				previousoutput=chapteroutput1;
				progress++;
			} catch (error) {
				console.error("ERROR Chapter");
			}

			
			var strippedPreviousoutput = previousoutput.replace(/<br>/gi, " ").replace(/(<([^>]+)>)/gi, "");

			wordcount=wordcount2;
			mode="chapterpart2";
			try {
				var chapteroutput2 = await getChapter(progress, chapter, projectname, language, chapters, wordcount, topic, audience, tone, booktitle, mode, chaptertitle, chaptersynopsis, strippedPreviousoutput);
				
				finaloutput+=chapteroutput1+chapteroutput2+'<hr><div style="page-break-before: always;"></div>';
				
				progress++;
			} catch (error) {
				console.error("Chapter part 2 error");
			}
				
			
		}

		$('#step3').hide();
		$('#step4').show();
		let parts = finaloutput.split('<br><br>');
		for(let i = 0; i < parts.length; i++) {
			parts[i] = '<p>' + parts[i] + '</p>';
		}
		let newText = parts.join('');	
		var editor = tinymce.get('editorarea');
		editor.setContent(newText);
		
		$('#docHtml').html('<style>p { color: black; font-size: 12pt; font-family: Verdana; } h1 {font-family: Verdana; }</style>'+finaloutput);
		var wordCount=getCount();
		var add2=$('#add2').val();
		if (add2==1){
			$.ajax({
				url: "AJAX_creditchange.php",
				type: "POST",
				data: { wordCount: wordCount },
				success: function(response){
					$('#usercredits').text(response);
				},
				error: function(error){
					console.log("Error:", error);
				}
			});
		}
	}	
});

function getChapter(progress, chapter, projectname, language, chapters, wordcount, topic, audience, tone, booktitle, mode, chaptertitle, chaptersynopsis, previousoutput){
    return new Promise((resolve, reject) => {
		var progpercent;
		if (progress<2*chapters - 1){
			progpercent = Math.round((progress / (2*chapters)) * 100);
		} else {
			var progpercent=95;
		}
		if (progpercent==0){progpercent=5;}
		
        $('#overlay-message').html('Asking AI to generate chapter '+chapter+'. Please wait...<br><div class="progress bg-secondary" style="height: 20px; margin-top:10px;"><div class="progress-bar bg-light" role="progressbar" style="width: '+progpercent+'%; color:#555;" aria-valuenow="'+progpercent+'" aria-valuemin="0" aria-valuemax="100">'+progpercent+'%</div></div>');
        showOverlay(true);
        var data = {
            projectname: projectname,
            language: language,
            chapters: chapters,
            wordcount: wordcount,
            topic: topic,
            audience: audience,
            tone: tone,
            booktitle: booktitle,
            mode: mode,
            chaptertitle: chaptertitle,
            chaptersynopsis: chaptersynopsis,
			previousoutput: previousoutput
        };
        $.ajax({
            url: 'AJAX_aiengine.php',
            type: 'POST',
            data: data,
			cache: false,
            success: function(response) {
				
				try {
				  errortest = JSON.parse(response);
				} catch (error) {
					console.error("The response is not valid JSON in GetChapter"); 
					
					showOverlay(false);
					$('#s2errorModal').modal('show');					  
				    errortest=response;
				}
				if (errortest.error){
					console.log("ERROR WITH AJAX CALL CHAPTER - errortest!!");
					
					showOverlay(false);
					$('#s2errorModal').modal('show');				
				} else {
					showOverlay(false);
					var airesp = JSON.parse(response);
					
					var content = airesp.choices[0].message.content;
					
					var content = content.replace(/\n/g, '<br>');
					var content = content.replaceAll('(To be continued...)', '');
					var content = content.replaceAll('To be continued', '');
					var content = content.replaceAll('TO BE CONTINUED', '');
					
					var content = content.replace(/\[.*?\]/g, '');
						
					resolve (content);
				}
            },
            error: function(xhr, status, error) {
                console.error(error);
                showOverlay(false);
                $('#s2errorModal').modal('show');
                reject(error); // Reject the Promise with the error
            }
        });
    });
}


$('.btn-number').click(function(e) {
    e.preventDefault();
    fieldName = $(this).attr('data-field');
    type = $(this).attr('data-type');
    var input = $("input[name='" + fieldName + "']");
    var currentVal = parseInt(input.val());
    if (!isNaN(currentVal)) {
        if (type == 'minus') {
            if (currentVal > input.attr('min')) {
                input.val(currentVal - 1).change();
            }
            if (parseInt(input.val()) == input.attr('min')) {
                $(this).attr('disabled', true);
            }

        } else if (type == 'plus') {

            if (currentVal < input.attr('max')) {
                input.val(currentVal + 1).change();
            }
            if (parseInt(input.val()) == input.attr('max')) {
                $(this).attr('disabled', true); 
            }

        }
    } else {
        input.val(0);
    }
});
$('.input-number').focusin(function() {
    $(this).data('oldValue', $(this).val());
});
$('.input-number').change(function() {

    minValue = parseInt($(this).attr('min'));
    maxValue = parseInt($(this).attr('max'));
    valueCurrent = parseInt($(this).val());

    name = $(this).attr('name');
    if (valueCurrent >= minValue) {
        $(".btn-number[data-type='minus'][data-field='" + name + "']").removeAttr('disabled')
    } else {
        $(this).val($(this).data('oldValue'));
    }
    if (valueCurrent <= maxValue) {
        $(".btn-number[data-type='plus'][data-field='" + name + "']").removeAttr('disabled')
    } else {
        $(this).val($(this).data('oldValue'));
    }
});

$(".input-number").keydown(function(e) {
    if ($.inArray(e.keyCode, [46, 8, 9, 27, 13, 190]) !== -1 ||
        (e.keyCode == 65 && e.ctrlKey === true) ||
        (e.keyCode >= 35 && e.keyCode <= 39)) {
        return;
    }
    if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
        e.preventDefault();
    }
});

function showOverlay(show) {
    if(show) {
        $('#overlay').addClass('display-flex');
    } else {
        $('#overlay').removeClass('display-flex');
    }
}

$(document).ready(function() {
	var ebook_category=$('#ebook_category').val();
	var ebook_contents=$('#ebook_contents').val();
	var ebook_id=$('#ebook_id').val();
	if(ebook_id>0){
		$('#step1,#step2,#step3,#regenButton,#cancelButton').hide();
		$('#step4').show();
		$("#categoryEdit").val(ebook_category).change();
	}
	$('#outerWrapper').show();
	tinymce.init({
		selector: '#editorarea',
		promotion: false,
		branding: false,
		inline_styles : true,
		content_style: "p { color: black; font-size: 12pt; font-family: Verdana; margin: 1rem auto; max-width: 1400px; }",	
		toolbar: "aligncenter alignjustify alignleft alignnone alignright| blockquote styles | image | link | bold italic underline strikethrough | copy | cut | fontfamily fontsize backcolor forecolor hr indent | language | lineheight | newdocument | outdent | paste pastetext | redo | selectall | searchreplace | subscript superscript | undo | fullscreen | code",
		plugins: "link, image, wordcount, fullscreen, code, searchreplace",	 
		setup: function (editor) {
		  editor.on('init', function (e) {
			editor.setContent(ebook_contents);
		  });
		}
	});	
	
	$('input:not(#step4 input), #projectnameEdit').on('input', function() {
	  var inputValue = $(this).val();
	  var sanitizedValue = inputValue.replace(/[^A-Za-z0-9\s\-!\[\]{}()*?#&+_\-=\,\.àáâãäåæçèéêëìíîïðñòóôõöøùúûüýþÿĀ-ž]/g, '');
	  $(this).val(sanitizedValue);
	});  
});

function getCount(){
	tinyeditor = tinymce.activeEditor;
	wordCount = tinyeditor.plugins.wordcount.getCount();
	return wordCount;
}

function enoughWords(){
	if ($('#add2').val()==1){
		var wordCount=parseInt($('#usercredits').text());
		var reqChapters=parseInt($('#chapters').val());
		var reqWords=parseInt($('#wordsperchapter').val());
		var bookSize=reqWords*reqChapters;
		if (bookSize<wordCount){
			return true;
		} else {
			return false;
		}
	} else {
		return true;
	}
}

</script>
<div id="overlay">
    <div id="overlay-text"><i class="fas fa-sync-alt fa-spin" style="margin-right:15px"></i><span id="overlay-message">Communicating with AI - Please Wait...</span></div>
</div>

</body>

</html>